#include <stdio.h>
#include <string.h>
#define  MAXLINE 256
#define  MAXNAME 15

void compare(char *fn1, FILE *fp1,
             char *fn2, FILE *fp2, FILE *out);

int main(int argc, char *argv[])
  {
    FILE *fp1, *fp2;
    
    if (argc < 3)
      {
        fprintf(stderr,
          "Usage: %s <file1> <file2>\n", argv[0]);
        return 1;
      }

    fp1 = fopen(argv[1], "r");  /* open file1 */
    fp2 = fopen(argv[2], "r");  /* open file2 */
   
    compare(argv[1], fp1, argv[2], fp2, stdout);

    fclose(fp1); fclose(fp2);
    return 0;
  }

void compare(char *fn1, FILE *fp1,
             char *fn2, FILE *fp2, FILE *out)
  {
    char line1[MAXLINE], line2[MAXLINE];
    char *pline1 = line1, *pline2 = line2;
    int lineno;

    for (lineno = 1; ; lineno++)
      {
        pline1 = fgets(line1, MAXLINE, fp1);
        pline2 = fgets(line2, MAXLINE, fp2);

        if (!pline1 && !pline2)
          {
            fprintf(out,"%s and %s are identical\n",
                         fn1, fn2);
            return;
          }
        else if (pline1 && !pline2)
          {
            fprintf(out,"Files differ at line %d\n",
                         lineno);
            fprintf(out,"%*s: %s",
                         MAXNAME, fn1, line1);
            fprintf(out,"%s exhausted\n", fn2);
            return;
          }
        else if (!pline1 && pline2)
          {
            fprintf(out,"Files differ at line %d\n",
                         lineno);
            fprintf(out,"%s exhausted\n", fn1);
            fprintf(out,"%*s: %s",
                         MAXNAME, fn2, line2);
            return;
          }
        else if (strcmp(line1, line2) != 0)
          {
            fprintf(out,"Files differ at line %d\n",
                         lineno);
            fprintf(out,"%*s: %s",
                         MAXNAME, fn1, line1);
            fprintf(out,"%*s: %s",
                         MAXNAME, fn2, line2);
            return;
          }
      }
  }
