/*
 *  unsafe append
 */

#include <stdio.h>
#define  MAXLINE 256

int main(int argc, char *argv[])
  {
    FILE *fp1, *fp2;
    char s[MAXLINE];
    int status = 0;
    
    if (argc != 3)
      {
        fprintf(stderr, "Usage: %s <file-1> <file-2>\n", argv[0]);
        return 1;
      }

    fp1 = fopen(argv[1], "a");
    if (fp1 == NULL)
      {
        fprintf(stderr, "%s: could not open %s\n", argv[0], argv[1]);
        return 1;
      }

    fp2 = fopen(argv[2], "r");
    if (fp2 == NULL)
      {
        fprintf(stderr, "%s: could not open %s\n", argv[0], argv[2]);
        fclose(fp1);
        return 1;
      }
   
    while (fgets(s, MAXLINE, fp2) != NULL) fputs(s, fp1);

    if (ferror(fp1))
      {
        fprintf(stderr, "%s: error in writing to %s\n", argv[0], argv[1]);
        status = 1;
      }

    if (ferror(fp2))
      {
        fprintf(stderr, "%s: error in reading from %s\n", argv[0], argv[2]);
        status = 1;
      }

    fclose(fp1);
    fclose(fp2);

    return status;
  }
