#include <stdio.h>
#define MAXPROBS 10  /* number of problems */
#define MAXTERMS 5   /* maximum terms in a problem */
#define LARGEST  10  /* largest value of a term */
#define SMALLEST 0   /* smallest value of a term */
#define MAXOPS   2   /* '+' and '*' */
#define SEED     781 /* for the random number generator */

#if defined ADD
    #undef MUL
    #undef MIX
    char  operator  = '+';
#elif defined MUL
    #undef ADD
    #undef MIX
    char  operator  = '*';
#else
    #define MIX
    #undef ADD
    #undef MUL
    char  operator;
#endif

char opcode[MAXOPS] = {'+', '*'};

int  rand(void); /* random number generator */
void srand(int); /* initializes the random number generator */
void probgen(int terms); /* problem generator */

int main(void)
  {
    int i, terms;

    srand(SEED);

    for (i=0; i < MAXPROBS; i++)
      {
        #ifdef MIX
            operator = opcode[rand() % MAXOPS];
        #endif
        terms = (rand() % (MAXTERMS-1) ) + 2;
        probgen(terms);
      }
    return 0;
  }

void probgen(int terms)
  {
    int i, spread = LARGEST - SMALLEST + 1;

    for (i=0; i < terms; i++)
      {
        printf("%2d", SMALLEST + rand() % spread);
        printf(" %c ", i < terms-1 ? operator : '=');
      }
    printf("\n");
  }
