/********************   io.c   *******************/

#include "global.h"

#define  BUFSIZE   80

void skip(void);

char buf[BUFSIZ];
int bp;  /* position in buf while parsing an expression */
         /* set to 0 in readexp after reading an expression */

int readexp(void)
  {
    int c, i;
    
    for(i = 0; i < BUFSIZE ; i++)
      {
        if (c = getchar(), c != EOF && c != '\n')
            buf[i] = c;
        else  /* reached the end of the expression */
          {
            buf[i] = '\0';  /* null terminate the expression */
            bp = 0; /* set bp to the beginning of the expression */
            return c == EOF ? NOMORE : OK;
          }
      }

    /* expression cannot fit in buf */

    buf[BUFSIZE-1] = '\0';/* null terminate whatever is in buf */

    /* discard the rest of the expression */
    while(c = getchar(), c != EOF && c != '\n');

    return ERR;
  }

void printexp(void)
  {
    printf("expression: %s\n", buf);
  }

int next(int *operator, int *operand)
  {
    /* skip over whitespaces */
    while(buf[bp] == ' ' || buf[bp] == '\t') bp++;

    if (buf[bp] == '\0')
        return NOMORE;
    else if (buf[bp] >= '0' && buf[bp] <= '9')
      {
        /* determine the integer value of the operand */
        for(*operand = 0;
            buf[bp] >= '0' && buf[bp] <= '9'; bp++)
                *operand = 10 * (*operand) +
                           (buf[bp] - '0');
        return OPERAND;
      }
    else
      {
        *operator = buf[bp++];
        return OPERATOR;
      }
  }
