/******************   bsort.c   ******************/

void bsort(char **data, int last,
           int (*compare)(char *, char *))
  {
    int  i, not_done;

    do
      {
        not_done = 0;

        /* scan and interchange as needed */

        for (i = 1; i < last; i++)
           
            if ((*compare)(data[i-1], data[i]) < 0)
              {
                char *p;

                /* out-of-order data; interchange pointers */
                p = data[i-1];
                data[i-1] = data[i];
                data[i] = p;

                not_done++;
              }

        /* do not scan the last data item in the next iteration */

        last--;

      } while (not_done);
  }
