/*
 *  Function to append a source string to a given destination string.
 *  The destination string is large enough to hold the longer string.
 *  Any lower case character in the original destination string is
 *  converted to upper case.  Any upper case character in the source
 *  string is converted to upper case in the appended string.
 */

#define islower(c) (c) >= 'a' && (c) <= 'z' ? 1 : 0
#define isupper(c) (c) >= 'A' && (c) <= 'Z' ? 1 : 0
#define tolower(c) (c) + 'a' - 'A'
#define toupper(c) (c) - 'a' + 'A'

char *findend_cnvrt(char *string);
void cpy_cnvrt(char *destination, char *source);

char *append(char *dst, char *src)
  {
    cpy_cnvrt(findend_cnvrt(dst), src);
    return dst;
  }

/*
 *  Locate the end of the string.  At the same time,
 *  covert to upper case any lower case letter in the string.
 */

char *findend_cnvrt(char *str)
  {
    for( ; *str; str++)
        if (islower(*str)) *str = toupper(*str);
    return(str);
  }

/*
 *  copy src to dst.  At the same time,
 *  covert to lower case any upper case letter in the copied dst.
 */

void cpy_cnvrt(char *dst, char *src)
  {
    for( ; *dst = *src; dst++, src++)
        if (isupper(*dst)) *dst = tolower(*dst);
  }
