#include <stdio.h>
#define  ITEMS    1000
#define  PRICES   5

struct iteminfo
  {
    int   item;
    float price[PRICES];
  };

void bld_database(struct iteminfo *db,
                  int items, float prices);
struct iteminfo *bsearch(int val,
                  struct iteminfo *db, int length);
float min_price(struct iteminfo *ip, int prices);

int main(void)
  {
    struct iteminfo database[ITEMS], *ip;
    int    item_no;

    /* build the item-price database */
    bld_database(database, ITEMS, PRICES);

    /* read the item_no of the item whose price is to be found */
    scanf("%d", &item_no);

    /* binary search */
    ip = bsearch(item_no, database, ITEMS);

    /* output */
    if (ip)
        printf("price of %d = %f\n",
                item_no, min_price(ip, PRICES));
    else
        printf("%d not in the database", item_no);

    return 0;
  }

void bld_database(struct iteminfo *database,
                  int items, float prices)
  {
    int i, j;

    for (i = 0; i < items; i++)
      {
        scanf("%d", &database[i].item);
        for (j = 0; j < prices; j++)
        scanf("%f", &database[i].price[j]);
      }
  }

struct iteminfo *bsearch(int val,
    struct iteminfo *database, int len)
  {
    int first = 0, last = len-1, mid;

    while (first <= last)
      {
        mid = (first + last) / 2;

        if (val == database[mid].item)
            /* search succeeds */
            return &database[mid];
        else if (val > database[mid].item)
            /* search the lower half */
            last = mid - 1;
        else
            /* search the upper half */
            first = mid + 1;
      }
    return NULL;
  }

float min_price(struct iteminfo *ip, int prices)
  {
    float min = ip->price[0];
    int j;

    for (j = 1; j < prices; j++)
         if (min > ip->price[j])  min = ip->price[j];
    return min;
  }
