/**************************   global.h   *************************/

#include <stdio.h>

/* error codes */

#define  STACKFULL   1
#define  STACKEMPTY  2
#define  LONGEXP     3
#define  ILLFORMEXP  4
#define  ILLEGALOP   5
#define  ZERODIVIDE  6

/* status codes */

#define  NOMORE      0
#define  OK          1
#define  ERR         2
#define  OPERATOR    1
#define  OPERAND     2

struct token
  {
    int type;  /* one of NOMORE, or OPERATOR, or OPERAND */
    union
      {
        int operator;
        char operand;
      } value;
  };

/* i/o functions */

int  readexp(void);
void printexp(void);
void  next(struct token *newterm);

/* stack functions */

void clearstack(void), push(int), printstack(void);
int  pop(void), stacksize(void);

/* error function */

void perror(void);

/* global variable */

extern int error;
